#if !defined(ZP_01_H__2F9BCAE4_A1B5_11D6_B9B1_90B34AC10101__INCLUDED_)
#define ZP_01_H__2F9BCAE4_A1B5_11D6_B9B1_90B34AC10101__INCLUDED_


#include "stdafx.h"
#include "hint_01.h"
#include <stdio.h>


class Zp
{protected:
 HugeInt m;

 public:
 static HugeInt p;

 void static getp(const HugeInt& p1) {Zp::p=p1;};
 Zp (HugeInt);
 Zp (UI);
 Zp ();
 Zp (const Zp&);
 Zp& operator = (const Zp&);
 HugeInt& getm ();
 void setm(HugeInt);
 
 friend int operator == (Zp, Zp);
 friend int operator != (Zp, Zp);

 friend Zp operator + (Zp, Zp);
 friend Zp operator - (Zp, Zp);
 friend Zp operator - (Zp);
 friend Zp operator * (Zp, Zp);
 friend Zp div1 (Zp, Zp);
 friend Zp operator / (Zp, Zp);
};

Zp::Zp () {};
Zp::Zp (UI m1) {m=m1%Zp::p;};
Zp::Zp (HugeInt m1) {m=m1%Zp::p;};
Zp::Zp (const Zp& m1) {m=m1.m;}


Zp& Zp::operator = (const Zp& m1) {m=m1.m; return *this;};

HugeInt Zp::p = 17;

HugeInt& Zp::getm () {return m;};

void Zp::setm(HugeInt  mm) {m=mm;};
 
Zp operator + (Zp a1, Zp a2)
{Zp res; res.m = (a1.m + a2.m)%Zp::p; return res;
};

int operator == (Zp a1, Zp a2)
{return (a1.m == a2.m); };

int operator != (Zp a1, Zp a2)
{return (a1.m != a2.m); };

Zp operator - (Zp a1, Zp a2)
{Zp res; 
 if (a1.m>a2.m) res.m = (a1.m - a2.m)%Zp::p; 
           else res.m = Zp::p - ((a2.m - a1.m)%Zp::p); 
  return res;
};

Zp operator - (Zp a1)
{Zp res; res.m = Zp::p - a1.m; return res;};

Zp operator * (Zp a1, Zp a2)
{Zp res; res.m=(a1.m*a2.m)%Zp::p; return res;
};

HugeInt aminbmultc (HugeInt a, bool flaga,
					HugeInt b, bool flagb,
					HugeInt c, bool flagc,
					bool * flagres)
{HugeInt res;
 HugeInt mlt;
 bool flagsub;
 bool flagmlt=!(flagb^flagc);
 mlt=b*c;
 if (mlt==0) flagmlt=1;
 flagsub=(a>=mlt);
 if (flagmlt) 
	{if (flaga) 
		{if (flagsub)
			{res=a-mlt;
			 *flagres=true;
			}
			else
			{res=mlt-a;
			 *flagres=false;
			};
		}
		else
		{res=a+mlt;
		 *flagres=false;
		};
	}
	else
	{if (flaga) 
		{res=a+mlt;
		 *flagres=true;
		}
		else
		{if (flagsub)
			{res=a-mlt;
			 *flagres=false;
			 if (res==0) *flagres=true;
			}
			else
			{res=mlt-a;
			 *flagres=true;
			};
		};
	};
return res;
};
					

Zp operator / (Zp aa1, Zp aa2)
{//Special thanks for Rostovtsev A.G.
 Zp res;
 HugeInt y = Zp::p;
 HugeInt x = aa2.m;
 HugeInt  a2=1; bool fa2=true;
 HugeInt  a1=0; bool fa1=true;
 HugeInt  b2=0; bool fb2=true;
 HugeInt  b1=1; bool fb1=true;
 HugeInt  a;  bool fa=true;
 HugeInt  b;  bool fb=true;
 
 HugeInt  q;
 HugeInt  r; bool fq=true;

 while (y!=0) {q=x/y; r=HugeInt::GetMod(); 
               a=aminbmultc(a2, fa2, q, fq, a1, fa1, &(bool)fa);
			   b=aminbmultc(b2, fb2, q, fq, b1, fb1, &(bool)fb);
			   x=y; y=r; 
			   a2=a1; fa2=fa1;
			   a1=a; fa1=fa;
			   b2=b1; fb2=fb1;
			   b1=b; fb1=fb;
			};
 a=a2; fa=fa2;
 if (!fa) a=Zp::p-a;
 res.setm(a);
 res=res*aa1;
 return res;
};

class EC
{Zp a;
 Zp b;
 Zp j;

 public:
     EC(Zp ae, Zp be) {a=ae; b=be; j=6912*a*a*a/(4*a*a*a+27*b*b);};
     
	 void newpars (Zp ae, Zp be)
		{a=ae; b=be; j=6912*a*a*a/(4*a*a*a+27*b*b);};
	 Zp GetA() {return a;};
	 Zp GetB() {return b;};
	 Zp GetJ() {return j;};
 friend class ECdot;
 };

class ECdot
{Zp x,y;
 EC* curve;
 bool nul;

 public:
	 ECdot () {nul=true;};
	 ECdot (Zp xx, Zp yy, EC* c, bool nl) 
			{if (yy*yy!=(xx*xx*xx+c->a*xx+c->b)) 
				{nul=true; curve=c;}
			 else
				{x=xx; y=yy; curve=c; nul=nl;};
			};
	 
	 ECdot (const ECdot& n) 
			{nul=n.nul; x=n.x; y=n.y; curve=n.curve;};
     
	 ECdot& operator = (const ECdot& n) 
			{x=n.x; y=n.y; curve=n.curve; nul=n.nul;
			 return *this;
			};

     void getpars(Zp xx, Zp yy, bool nl, EC * c)
		   {if (yy*yy!=(xx*xx*xx+c->a*xx+c->b)) 
				{nul=true; curve=c;}
			 else
				{x=xx; y=yy; curve=c; nul=nl;};
			};
	 
	 bool retnul () {return nul;};
	 Zp retX () {return x;};
	 Zp retY () {return y;};

	 bool operator == (const ECdot& n) 
			{return ((nul==n.nul)&&(x==n.x)&&
			         (y==n.y)&&(curve==n.curve));};
	 
	 bool operator != (const ECdot& n) 
			{return ((nul!=n.nul)||(x!=n.x)||
			        (y!=n.y)||(curve!=n.curve));};
	 
     ECdot& operator- ()
			{y=Zp::p-y; return *this;};

	 ECdot& operator+= (const ECdot& oth)
	 {ECdot res;
	  ECdot oth1=oth;
	  Zp lambda;
	  if (*this==(-oth1)) {this->nul=true; return *this;};
	  if (this->nul) {*this=oth; return *this;};
	  if (oth.nul) {return *this;};
	  if (*this==oth) 
			{lambda=(oth.x*oth.x*3+oth.curve->a)/(2*oth.y);}
			else
			{lambda=((this->y - oth.y)/(this->x - oth.x));};
	  res.x=(lambda*lambda-this->x)-oth.x;
	  res.y=lambda*(this->x-res.x)-this->y;
	  res.nul=false;
	  res.curve=curve;
	  *this=res; return *this;
	 };

	 ECdot& operator-= (const ECdot& oth)
	 {ECdot res=oth;
	  res=-res;
	  operator+=(res);
	  return *this;
	 };


	 ECdot& operator*= (const HugeInt& k)
	 {ECdot deg=*this;
	  ECdot res;
	  HugeInt bin=k;
	  if (bin==0) {this->nul=true; return *this;};
	  if (this->nul) {return *this;};
	  res=ECdot();
	  while (bin!=0)
			{if (bin.odd()) res+=deg;
	         bin>>=1;
			 deg+=deg;
			};
	  *this=res;
	  return *this;
	 };

};

	 
ECdot operator + (ECdot a, ECdot b)
	 {ECdot res=a;
	  res+=b;
	  return res;
	 };

	 ECdot operator - (ECdot a, ECdot b)
	 {ECdot res=a;
	  res-=b;
	  return res;
	 };

	 ECdot operator * (ECdot a, HugeInt b)
	 {ECdot res=a;
	  res*=b;
	  return res;
	 };
	 
	 ECdot operator * (HugeInt a, ECdot b)
	 {ECdot res=b;
	  res*=a;
	  return res;
	 };

#endif // !defined(ZP_H__CFB99B82_EDCB_11D6_B9B1_00C0DF1485FF__INCLUDED_)